﻿class Program {
	static void f(int? x) {
		if (x is int a) {
			Console.WriteLine(a + 10);
		}
		// Error: Use of unassigned local variable 'a'
		// Console.WriteLine(a);

		int c;
		if (x is int) {
			c = (int) x;
			Console.WriteLine(c + 100);
		}
		// Error: Use of unassigned local variable 'c'
		// Console.WriteLine(c);

        {
			if (x is int b) {
				Console.WriteLine(b + 1000);
			} else {
				// Error: Use of unassigned local variable 'b'
				// Console.WriteLine(b);

				b = 0;
			}
			Console.WriteLine(b + 2000);
		}

		// Error: The name 'b' does not exist in the current context
		// Console.WriteLine(b);
	}

	static void Main(string[] args) {
		f(3);
        Console.WriteLine("---");
        f(null);
	}
}